//=======================================================================================
// Copyright Nuvoton(SH) Technology Corp. All rights reserved. 2016/01/01   
//=======================================================================================
#define   Mini5xxDE_GLOBAL          
#include  "Mini5D_BLDC_V9.h"        
#include  "Mini5D_BLDC.h"   

#define   ACMP_PH_PWM01            CMP1_PIN_P32                  // ACMP0
#define   ACMP_PH_PWM23            CMP1_PIN_P34             
#define   ACMP_PH_PWM45            CMP1_PIN_P35  

#define   PWM_COMPL                (0x4000ul)                    
#define   DETEC_UP                 0x80                          // PHCHGָʾصλ
#define   PWM1_OUT_EN              0                             // PWM1  A- ź 
//#define   PWM1_OUT_EN            0x0200                     

// PWM024 PWM,MOSͨ, PWM135ź,MOSͨ ////////////////////////////
#define   PHASE_AB                PWM1_OUT_EN | (0x0162ul)               
#define   PHASE_AC                PWM1_OUT_EN | (0x014Aul)                     
#define   PHASE_BC                PWM1_OUT_EN | (0x044Aul)                      
#define   PHASE_BA                PWM1_OUT_EN | (0x0468ul&(~0x40))   // P0.1_D6 A- ź                     
#define   PHASE_CA                PWM1_OUT_EN | (0x1068ul&(~0x40))   // A-ҲɽP0.1_D6         
#define   PHASE_CB                PWM1_OUT_EN | (0x1062ul)                     

#define   PHASE_AB_   PWM_COMPL | PWM1_OUT_EN | (0x0362ul)        
#define   PHASE_AC_   PWM_COMPL | PWM1_OUT_EN | (0x034Aul)            
#define   PHASE_BC_   PWM_COMPL | PWM1_OUT_EN | (0x0C4Aul)                          
#define   PHASE_BA_   PWM_COMPL | PWM1_OUT_EN | (0x0C68ul&(~0x40))                           
#define   PHASE_CA_   PWM_COMPL | PWM1_OUT_EN | (0x3068ul&(~0x40))                               
#define   PHASE_CB_   PWM_COMPL | PWM1_OUT_EN | (0x3062ul)                   

// ת,/////////////////////////////////////////////////////////////////////////////
uint32_t TabPhase[25] = {                                     
    T0_TRG_PWM_EN | PHASE_CA  | ACMP_PH_PWM23 ,            //Ա,ǰһʱ,Խ
  
    T0_TRG_PWM_EN | PHASE_CB  | ACMP_PH_PWM01 | DETEC_UP ,    // 0,ϹPWM,ǻ,¹ܽ  
    T0_TRG_PWM_EN | PHASE_AB  | ACMP_PH_PWM45 ,              
    T0_TRG_PWM_EN | PHASE_AC  | ACMP_PH_PWM23 | DETEC_UP ,   
    T0_TRG_PWM_EN | PHASE_BC  | ACMP_PH_PWM01 ,            
    T0_TRG_PWM_EN | PHASE_BA  | ACMP_PH_PWM45 | DETEC_UP , 
    T0_TRG_PWM_EN | PHASE_CA  | ACMP_PH_PWM23 ,             
  
    T0_TRG_PWM_EN | PHASE_CB_ | ACMP_PH_PWM01 | DETEC_UP ,    //1,ϹPWM,ģʽ,¹ܿ
    T0_TRG_PWM_EN | PHASE_AB_ | ACMP_PH_PWM45 ,             
    T0_TRG_PWM_EN | PHASE_AC_ | ACMP_PH_PWM23 | DETEC_UP ,   
    T0_TRG_PWM_EN | PHASE_BC_ | ACMP_PH_PWM01 ,            
    T0_TRG_PWM_EN | PHASE_BA_ | ACMP_PH_PWM45 | DETEC_UP , 
    T0_TRG_PWM_EN | PHASE_CA_ | ACMP_PH_PWM23 ,             
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x1060ul&(~0x40)),         // 150-Wave, 2150ȷ 
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x1162ul),                 
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0142ul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x054Aul),           
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0448ul&(~0x40)),  
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x1468ul&(~0x40)),  
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x087A | ACMP_PH_PWM01 | DETEC_UP ,  // 3,Up-GPIO, Dwon-PWM 
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x086B | ACMP_PH_PWM45 ,            
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x206B | ACMP_PH_PWM23 | DETEC_UP ,   
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x206E | ACMP_PH_PWM01  ,            // B+ -> C-PWM
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x026E | ACMP_PH_PWM45 | DETEC_UP , 
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x027A | ACMP_PH_PWM23 ,             // C+ -> A-PWM
};    

// ת /////////////////////////////////////////////////////////////////////////////
uint32_t TabPhaseRev[25] = {                               
    T0_TRG_PWM_EN | PHASE_BA  | ACMP_PH_PWM45 ,    
  
    T0_TRG_PWM_EN | PHASE_BC  | ACMP_PH_PWM01 | DETEC_UP ,   // 0,ϹPWM,ǻ,¹ܽ 
    T0_TRG_PWM_EN | PHASE_AC  | ACMP_PH_PWM23 ,   
    T0_TRG_PWM_EN | PHASE_AB  | ACMP_PH_PWM45 | DETEC_UP ,    
    T0_TRG_PWM_EN | PHASE_CB  | ACMP_PH_PWM01 ,      
    T0_TRG_PWM_EN | PHASE_CA  | ACMP_PH_PWM23 | DETEC_UP ,         
    T0_TRG_PWM_EN | PHASE_BA  | ACMP_PH_PWM45 ,                    
  
    T0_TRG_PWM_EN | PHASE_BC_ | ACMP_PH_PWM01 | DETEC_UP ,   //1,ϹPWM,ģʽ,¹ܿ
    T0_TRG_PWM_EN | PHASE_AC_ | ACMP_PH_PWM23 ,   
    T0_TRG_PWM_EN | PHASE_AB_ | ACMP_PH_PWM45 | DETEC_UP ,    
    T0_TRG_PWM_EN | PHASE_CB_ | ACMP_PH_PWM01 ,      
    T0_TRG_PWM_EN | PHASE_CA_ | ACMP_PH_PWM23 | DETEC_UP ,               
    T0_TRG_PWM_EN | PHASE_BA_ | ACMP_PH_PWM45 , 
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0448ul),  
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x054Aul),              // 150-Wave for "Up-PWM, Down-GPIO"
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0142ul),          
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x1162ul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x1060ul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x1468ul), 
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x206E | ACMP_PH_PWM01 | DETEC_UP, // B-on, C-pwm  
    T0_TRG_PWM_EN |             PHASE_AC | ACMP_PH_PWM23 ,   
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x086B | ACMP_PH_PWM45 | DETEC_UP, // A-on, B-pwm  
    T0_TRG_PWM_EN |             PHASE_CB | ACMP_PH_PWM01 ,      
    T0_TRG_PWM_EN | PWM1_OUT_EN | 0x027A | ACMP_PH_PWM23 | DETEC_UP, // C-on, A-pwm        
    T0_TRG_PWM_EN |             PHASE_BA | ACMP_PH_PWM45 ,                    
};    

uint32_t  Shut_All_MOS = 0x6A | PWM1_OUT_EN ;             // ͣתʱдPHCHGض·MOS  
uint32_t  Speed_Measure ;       
uint32_t  Active_Fail_Num ;                               // תʧܼ    

uint32_t static  Active_Tick=0, Active_TimeOV = 0 ;       // תǰʱ, תʱ

//=======================================================================================
void UnlockReg(void)   
{
  while((GCR->RegLockAddr & 1) == 0){                     // ֹϽɹ
    GCR->RegLockAddr = 0x59 ; 
    GCR->RegLockAddr = 0x16 ;  
    GCR->RegLockAddr = 0x88 ;  
  }
} 
void SystemInit(void)       
{
  UnlockReg();   
    CLK->PWRCON  = 0x001C ; 
    CLK->CLKDIV  = ADC_CLK_DIV_8bit(3) ;                   // ADC ʱ 22M/3 = 7M
    CLK->CLKSEL0 = CLKS0_HCLK_22M_ | CLKS0_TICK_HCLK_DIV2_ ; 
    CLK->CLKSEL1 = CLKS1_PWM23_HCLK | CLKS1_PWM01_HCLK | CLKS1_UART_22M | CLKS1_TMR1_HCLK 
                 | CLKS1_TMR0_HCLK  | CLKS1_ADC_22M    | CLKS1_WDT_10K_ | CLKS1_SPI_22M ;
    CLK->CLKSEL2 = CLKS2_PWM45_HCLK ;
    CLK->APBCLK  = CLK_ADC_EN | CLK_PWM45_EN | CLK_PWM23_EN | CLK_PWM01_EN | CLK_UART_EN           
                 | CLK_TMR1_EN | CLK_TMR0_EN | CLK_ACMP_EN  | CLK_SPI_EN   |CLK_WDT_EN ; 
 
  SysTick->VAL   = 100*11000 ;			                           
  SysTick->LOAD  = 100*11000 ;                             // Period = 0.1S, CLK=22Mhz/2
  SCB->SHP[1]    = ~0 ;                                    // Interrupt priority = 3 
  SysTick->CTRL  = 0x0003 ;                                // IE & EN
}
void Delayus(uint32_t Time)                                // 16777216(Լ16.5)
{
  uint32_t T1 = TIMER1->DR ; 
  while(((TIMER1->DR - T1) & 0xFFFFFF) < Time) ;         
}
void PWM024_0_MOS_On(void)                                 // PWM0240ʱʹܵͨ,ô˺
{
  uint32_t n ;
  PWM->PCR ^= (PCR_INV_EN(0)|PCR_INV_EN(2)|PCR_INV_EN(4)) ;          
  for(n=0; n<25; ++n){TabPhase[n] ^= 0x15; TabPhaseRev[n] ^= 0x15; } 
  Shut_All_MOS ^= 0x15 ;                                            
}
void PWM135_1_MOS_On(void)                                // PWM1351ʱʹܵͨ,ô˺ 
{
  uint32_t n ;
  PWM->PCR ^= (PCR_INV_EN(1)|PCR_INV_EN(3)|PCR_INV_EN(5)) ;         
  for(n=0; n<25; ++n){TabPhase[n] ^= 0x6A; TabPhaseRev[n] ^= 0x6A; }   
  Shut_All_MOS ^= 0x6A ;
}
#define  BRK1_SOURCE_CPO0      0x04  
void Timer_ACMP_PWM_Init(void) 
{
  TIMER0->CSR  =  T_CRST | T_MODE_PERIODIC | T_WR_TCMP_NO_RST | T_TDR_EN + 21 ;  
  TIMER1->CSR  =  T_CRST | T_MODE_CONTINUOUS | T_TDR_EN + 21 ;   // 22 Ƶ
  TIMER1->CSR |=  T_CEN ;                                        // ʼ
  NVIC_SetPriority(TMR1_IRQn, 1) ;                          
  NVIC->ISER[0] = 1<<TMR1_IRQn ;                                 // ˺Delayus()

  ACMP->SR   = ~0 ;  
  ACMP->CR0  =  ACMP_CPP0_P10 | ACMP_EN ;	                       // ACMP0 ѡ P1.0 ӵ 
  ACMP->RVCR =  13 ;                                             // ˵ѹ(13+4)*5/24 = 3.5V
  ACMP->CR1  =  ACMP_EN ;               

//  DetectUpBit = DETEC_UP ;
//  AcmpOutBit  = ACMP_OUT1 ;                                    // ACMP1  
//  PWM024_0_MOS_On() ;                 // PWM024ʱMOSͨ,ô˺     
//  PWM135_1_MOS_On() ;                 // PWM135ʱMOSͨ,ô˺ 
	
  PWM->PPR = PPR_DIV45(2)   | PPR_DIV23(2)   | PPR_DIV01(2) ;    // PWM clk divide by 2
  PWM->CSR = CSR_DIV1_CH(5) | CSR_DIV1_CH(4) | CSR_DIV1_CH(3)    // CSR, no divide
           | CSR_DIV1_CH(2) | CSR_DIV1_CH(1) | CSR_DIV1_CH(0) ;   
  
  PWM->CMR0 = 0 ;       PWM->CMR1 = 0 ;    
  PWM->PCR = PCR_GROUP_MODE | PCR_CLR_COUNTER         
     | PCR_COMPLE | PCR_DZEN45_EN | PCR_DZEN23_EN | PCR_DZEN01_EN  
     | PCR_CH_EN(5) | PCR_PERIOD_MODE(5) | PCR_INV_EN(1) | PCR_CH_EN(4) | PCR_PERIOD_MODE(4) 
     | PCR_CH_EN(3) | PCR_PERIOD_MODE(3) | PCR_INV_EN(3) | PCR_CH_EN(2) | PCR_PERIOD_MODE(2) 
     | PCR_CH_EN(1) | PCR_PERIOD_MODE(1) | PCR_INV_EN(5) | PCR_CH_EN(0) | PCR_PERIOD_MODE(0);
  PWM->PDZIR = 0x111111 ;                                  // Deadtime = 0x11+1 CLK,about 1.6us

  PWM->PHCHGNXT   = Shut_All_MOS ;                         
  PWM->PHCHG      = Shut_All_MOS ;      
  PWM->PFBCON     = (Shut_All_MOS<<24) | BRK1_SOURCE_CPO0 ;             // disable INT1(ACMP0) break 
//  PWM->PFBCON     = (Shut_All_MOS<<24) | BRK1_SOURCE_CPO0 | BRK1_EN;  // enable INT1(ACMP0) break 

  PWM->POE        = 0x3F ;                                       // Enable PWM output
  PWM->PHCHGMASK  = PHCHG_CTL_CMP1 | P01_OUT_D6 | P00_OUT_D7 ;          
  
  PWM->TRGCON0    = 0x0008 ;                                     // PWM0 0㴥 ADC 
  PWM->INTACCUCTL = 0 ;                               
  PWM->PIIR       = ~0 ;  
  PWM->PIER       = PIER_BRKE_IE + PIER_PIE(0);                  // BRKIE  PWM0 жʹ
  NVIC_SetPriority(FB_IRQn, 0) ;                                 // Brake ж 
  NVIC->ISER[0]  = 1 << FB_IRQn ;                        	
}
////  Set_BLDC_Free() · MOS ͣת ///////////////////////////////////
void FB_IRQHandler(void)                               
{            
  PWM->PHCHGMASK &= ~P01_OUT_D6;
  GCR->P2_MFP  = 0;                                    
  GCR->P0_MFP &= ~0x1010;                                  // 6·ʹлGPIO 
  
  ACMP->SR     = ACMP_CF1 | ACMP_CF0 ;                  
  ACMP_Flag   |= ACMP_SHORT ;  
  PWM->PIIR    = ~0 ;                          
  LED_LIGHT() ;                                                  // ָʾ brake
  PWM->PFBCON |= 0x80 ;                                          // жϱ־   
  PWM->PCR    |= PCR_CH_EN(5) | PCR_CH_EN(4) | PCR_CH_EN(3)      // ʹ PWM 
               | PCR_CH_EN(2) | PCR_CH_EN(1) | PCR_CH_EN(0) ;  
  Delayus(25) ; 
  if(++CntBrake > 10){CntBrake = 0;  ACMP_Flag |= ACMP_SHUT_MOS; }   //Brake, ·        
  else{  
    PWM->PHCHGMASK |= P01_OUT_D6 ;                               // BrakeС,Ǹ,ָŹ             
    GCR->P0_MFP   |= 0x1010 ; 
    GCR->P2_MFP   = 0x2800 ;        
    Delayus(5) ;
    GCR->P2_MFP = 0x7C00 ;                                       // 6·PWMлPHCHG 
  }      
}
uint32_t Wait_Level(uint32_t Level, uint32_t Cnt, uint32_t TimOV)   //ȴƽLevelCnt
{
  uint32_t temp32, Tim1 = TIMER1->DR , Tim2 = Tim1, Flag = 0 ;  
	                                     
  do{ 
    temp32 = ACMP->SR & AcmpOutBit ; 
    Delayus(2);                                                  // 2usACMPͬ
    if(temp32 == (ACMP->SR & AcmpOutBit)){                      
      if(Level){
        if(temp32){ if(++Flag >= Cnt) break;   }                 // Nͬ,עʱ
        else{ Flag = 0;  Tim2 = TIMER1->DR;  }
      }
      else if(temp32 == 0){ if(++Flag >= Cnt) break;   } 
      else{ Flag = 0;   Tim2 = TIMER1->DR;  }
    }		
  }while(((TIMER1->DR - Tim1) & 0xFFFFFF) < TimOV) ;  
  return (Flag <<24) + Tim2 ;
}

uint32_t BLDC_Test(uint32_t TimOv)                               // ʱʱ
{
  uint32_t temp1, temp2;
                                                                
  PWM->PHCHGNXT = (*pPhase & 0xFFFF0000) | Shut_All_MOS ;          
  PWM->PHCHG    = (*pPhase & 0xFFFF0000) | Shut_All_MOS ;        // Ƚѡ	
  Delayus(100) ;
	
  if((Wait_Level((*pPhase & DetectUpBit) ^ DetectUpBit, 30, TimOv)& ~0xFFFFFF) == 0) return 1;	
  temp1 = Wait_Level((*pPhase & DetectUpBit), 30, TimOv) ;  
  if((temp1 & ~0xFFFFFF) == 0) return 0;	   
                         // ,ADCⷴ,תռձȵĲο  
  if((Wait_Level((*pPhase & DetectUpBit) ^ DetectUpBit, 30, TimOv)& ~0xFFFFFF) == 0) return 1;	  
  temp2 = Wait_Level((*pPhase & DetectUpBit), 2, TimOv) ;  
  if((temp2 & ~0xFFFFFF) == 0) return 0;	   
  
  temp2 = (temp2 - temp1) & 0xFFFFFF ;                  
  temp2 = (temp2 * 43) >> 8 ;                                    //  6            
  
  return temp2 ;                                                 // ڹ0ʱ̷
}

//  Timer1 жϲܵô˺,򷵻Timer1жϺִMOS,TIMER1жϹرԺٻ  
void Set_BLDC_Free(void)                                         // عʹ,ͣת
{                                       
  TIMER1->CSR  &= ~T_IE ;                                        // ж, жٸPHCHGNXT
  PWM->PHCHGNXT =  Shut_All_MOS ;                                //  MOSFET
  PWM->PHCHG    =  Shut_All_MOS ;   
  GCR->P0_MFP  |= 0x1010 ;                                       // BrakeʱGPIO,ָPWM
  GCR->P2_MFP   = 0x7C00 ;   
    
  Active_TimeOV = 0 ;                                            // תʱ0
  ACMP_Flag    = 0 ;                                             // Brake ־0                                                                         
  PWM->CMR0   = 0 ;  
  Delayus(3) ;                                                   //  MOS ȫض
}

void BLDC_Add_Duty(int32_t DInc, uint32_t Delay)            
{ 
  if(((TIMER1->DR - TickChangDuty) & 0xFFFFFF) >= Delay){                      
    TickChangDuty = TIMER1->DR ;                            
    Duty_Limit += DInc ;  
  } 
}
////=====================================================================================
void  BLDC_Control(int32_t Run_Command)                          // >0ת, <=0ת
{
   int32_t  DutyInc = 0, temp32 = 0 ;                            // ֵ  
    
  uint32_t static  PhaseOut = 0 ;                                // ǰλָ
  uint32_t static  Last_Zero ;                                   // ϴι0ʱ
    
  if((TIMER1->CSR & T_IE) == 0){                                 // ûת                                       
    if((Run_Command >0)&&((Active_Tick - SysTick_Relay) >= Active_TimeOV)){   // תǰʱ   
//    First_Delay = 3000 ;	                                     // תʱĻ,ȱʡ3ms   
      PeriodMax   = 30*1000 ;		                                 // ֵ,ȱʡ60ms                     
      FilterRCTime = 80 ;
      pPhaseEnd   = &TabPhase[6] ;                               // ת      
//    pPhaseEnd   = &TabPhaseRev[6] ;                            // ת
      pPhase      = pPhaseEnd ;                                  // ת 
      
      ACMP->CR1  =  ACMP_EN | ACMP_HYST_EN ;                     // ʹ ACMP ز,ڷ                    
      temp32 = BLDC_Test(21*1000) ;                              // 21/3=7ms,1400rpmͣת 
      ACMP->CR1  =  ACMP_EN ;  
      if(temp32 < 100) temp32 = PeriodMax ;                      //  100Krpm? , ͣת      
      else if(temp32 >= 5*1000){    
        PWM->PHCHG = Shut_All_MOS ^ 0x42 ;  Delayus( 3*1000);    // PWM1 A- 
        PWM->PHCHG = Shut_All_MOS ^ 0x4A ;  Delayus( 3*1000);    // PWM13ͨ, B-
        PWM->PHCHG = Shut_All_MOS ^ 0x6A ;  Delayus(10*1000);    // ·MOS ȫͨ, Ծٵݳ        
        PWM->PHCHG = Shut_All_MOS ;         Delayus(10) ;
                                                                 // ֵ16λλ
//        PWM->PHCHGNXT = *pPhaseEnd ;
//        PWM->PHCHG    = PWM->PHCHGNXT ;
//        Duty_Limit    = 4*PWM_ONE_PERCENT ;
//        Delayus(100*1000);
        
//        pPhase =pPhase-5+(uint16_t)(BLDC_Get_Current_Min(80,&TabPhase[13],ADC7_CURRENT,0));
        if(ACMP_Flag & ACMP_SHORT){gFlag |= Flag_SHORT;  Set_BLDC_Free(); return; } // ·˲ת
        temp32 = PeriodMax ;
      }
      
      Duty_Limit = 4*PWM_ONE_PERCENT ;                           // תʱռձ     
      if(temp32 <1000) BLDC_Start(temp32, 0);                    // <1ms,˳ת,ֱͬ  
      else          BLDC_Start(temp32, 1000);                    // ת   
                           // ͵ȸٵҪACMP1ز,220/380VŴʹܻز
      PhaseOut = PWM->PHCHGNXT ;                                 // ֹϸı CntPWM ֵ      
      Last_Zero = TIMER1->DR ;        
      PhaseAngle  = 22 ;                                         // ͨ0~30
      Active_Tick  = SysTick_Relay ;                      
      Active_TimeOV = 3 ;                                        // תʱ
    }   
  } 
  else{ BLDC_Modify(0,30);                                     // 30ι0õ0黻ҵʱ
    if(StepCount <= 9){                          //== ת׶ ===                                     
      if(Run_Command <= 0) Set_BLDC_Free();                                  // ͣתָ, ֹͣת             
      else if((Active_Tick -SysTick_Relay) >Active_TimeOV){Set_BLDC_Free();  // תʱ          
        if(++Active_Fail_Num >=5){Active_Fail_Num = 0;  gFlag |= Flag_ACTIVE_FAIL; }  //תʧ
        else{ 
          Active_TimeOV = 3;                                                 // ´תʱ  
        }
      }
      else if(PhaseOut != PWM->PHCHGNXT){ PhaseOut = PWM->PHCHGNXT;          // ռ쵽0
        if(StepCount <= 6){
          if(Duty_Limit >9*PWM_ONE_PERCENT) Duty_Limit -= 3*PWM_ONE_PERCENT;  //ѹ(١)      
        }          
        else {                                                                
          if(Duty_Limit > 50*PWM_ONE_PERCENT) Duty_Limit = 50*PWM_ONE_PERCENT ;
        }
        
        temp32 = (ZeroTick - Last_Zero)&0xFFFFFF ;                  // ϴλ
        Last_Zero = ZeroTick ;                                                        
//        if(temp32 >(10000000ul/(1000*NUM_MAGNETIC_POLE)))         // תٹ
            Duty_Limit += 3 ;                                       // ÿһ,ѹһ                                                                
      }    
    }		       
    else{    //== ת׶: ڵͨ,ڵѹ ===============================
      if(PhaseOut != PWM->PHCHGNXT){  PhaseOut = PWM->PHCHGNXT ;  
        temp32 = PeriodNow ;         
        temp32 = (10000000ul + (temp32 >>1))/temp32 ;               // õת RPM
        Speed_Measure = (temp32 + Speed_Measure*7 +4) >>3 ;         // һ˲
                                              
        if(Run_Command <= 0){                                       // ͣתָ
//          if(Speed_Measure <50*NUM_MAGNETIC_POLE)
          if(PeriodNow > PeriodMax/4)                               // תٺܵʱͣת,Լ   
              Set_BLDC_Free();                                            
        }
//        else if(PeriodNow <(10000000ul/200000))  Set_BLDC_Free() ;   // תٳ,ͣת        
        
        if(StepCount < 6*6){ if(StepCount & 1) ++Duty_Limit ;       // ȶ׶, ѹʵ                                              
          if((Duty_Limit <13*PWM_ONE_PERCENT)&&(PeriodNow <(10000000ul/20000))){ //ת,Լ
            Set_BLDC_Free() ;                                                    // ,Լ
            if(++Active_Fail_Num >= 5){Active_Fail_Num = 0;  gFlag |= Flag_ACTIVE_FAIL; }
            else{ 
              Active_TimeOV = 6;                    // ´תʱ  
            }
          }            
        }
        else{ 
          temp32 = (uint16_t)(Duty_Limit >> 6) ;                 // 800/64 = 12.5       
          if(temp32 > 12) temp32 = 12 ;                           
          PhaseAngle = 22 - temp32 ;                             // 22~10ѹ(ת)ͨ
          
          // Ҫ, Run_Command =Ŀת, ĵѹ, ΪתPI
          
          if(Run_Command > Duty_Limit) DutyInc = 1;      // Run_Command=Ŀռձ(Ŀתٲͬ)
          else Duty_Limit = Run_Command;                                        	
          
          if(Duty_Limit >= 85*PWM_ONE_PERCENT)    BLDC_Add_Duty(DutyInc, 1000) ; // 1ms duty1 
          else if(Duty_Limit >25*PWM_ONE_PERCENT) BLDC_Add_Duty(DutyInc, 2000) ; // 2ms duty1    
          else                                    BLDC_Add_Duty(DutyInc, 3000) ; // 3ms duty1            
          
          if(Duty_Limit < 9*PWM_ONE_PERCENT) Duty_Limit = 9*PWM_ONE_PERCENT;   // ӿʱ
        }
      }	  // End of ռ쵽0	                                                                         
    }  //======== End of ת׶ ============================================================== 

    if(ACMP_Flag & ACMP_SHUT_MOS){ Set_BLDC_Free();  gFlag |= Flag_SHORT; }  // Brake,ܶ·
    if((TIMER1->CSR &T_IE) == 0) Active_Tick = SysTick_Relay;  // ͣת,´תǰʱActive_TimeOV
  }
}
//// ѷFiFo /////////////////////////////////////////////////////////////////////
// β :  *pStr, ַָ
//          Cnt , ַ
//  :   Cnt,  ʣַ
uint32_t Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{
  while(Cnt){                                              
    if( UART0->FSR & TX_FIFO_FULL ) break ;                // FiFo˾˳ѭ        
    UART0->THR = *pStr++ ;   --Cnt ;                       // ֱ
  }
  return  Cnt ;                               
}
////convert a integer into a string for printing /////////////////////////////////////////
//input : Number, 32bit integer
//       *pStr,  the last address saving character.  
//return: Sum of character converted.
const uint8_t Asc[10]="0123456789" ;
uint32_t HexToStr(uint32_t Number, uint8_t*pStr)
{
  uint32_t temp32u, Cnt = 0 ;

  do{ temp32u = Number ;
    Number /= 10 ; 
    *pStr-- = Asc[temp32u - Number*10] ; 
    ++Cnt ;
  }while(Number);
  return Cnt ;
}
