//=======================================================================================
// Copyright Nuvoton(SH) Technology Corp. All rights reserved. 2016/01/01   
//=======================================================================================
// ʱ׼ Timer0/1 ʱӶ 22.1184M/22 = 1MHz,  1000 Ϊ 1ms 
#include  "Mini5D_BLDC_V9.h"   
#include  "Mini5D_BLDC.h"           

#define  VIN_MIN_L          (150)                          // 0.1Vֵ, ͣתĵѹֵ
#define  VIN_MIN_H          (160)                          // ѹ
#define  VIN_HIGH           (400)                          // ѹͣת
int32_t  Vin_Min = VIN_MIN_H  ; 

int32_t volatile Adc_Vin = 250 ;                           // Դѹ ADC ֵ

#define  CUR_RES                   50                      // ŷ*˷ű 
int32_t const CURRENT_LIMIT = ((20*CUR_RES*1024)/5000);    // ֵ 20A
int32_t const CURRENT_PEAK  = ((30*CUR_RES*1024)/5000);    // ֵ
uint32_t      Current_Cofficient ;                         // ϵ

uint32_t          Duty_Min  =  6*PWM_ONE_PERCENT ;
int32_t  volatile Duty_Command = 20*PWM_ONE_PERCENT ;      // Duty ,Χ 0 ~ CNR

volatile uint32_t Adc_Bat_Tempera = (1000*1024/(270+1000));  // 25 ADC ֵ
uint32_t  Tick_Voltage ;

////=====================================================================================             
////UART0 Initial ///////////////////////////////////////////////////////////////////////
void UART0_Init(uint32_t Baud)                 
{
  UART0->FUN_SEL = 0  ;                                          //UART ģʽ
  UART0->LCR     = 0x0007 ;                                      //8bit, 2-stop, no parity
  UART0->BAUD    = 0x30000000 + 22118400/Baud - 2 ;              //UART ʱ 22M
  UART0->FCR     = 0x00020020 ;                                  //RTS trigger:8,FIFO trigger:8 BYTE
  UART0->IER     = 0 ;                                   
}
/////////////////////////////////////////////////////////////////////////////////////////
// Configure P2.23456 & P0.4 as PWM function pin.  configure P1.0345 as ACMP input pin
void GPIO_Init(void) 
{                                          // P0.1óOUTģʽ,PHCHG,QBģʽ                                                              
  if(Shut_All_MOS & 0x20) GPIO0->DOUT = 0xFD ;                   // P0.4 ض MOS
  else GPIO0->DOUT = 0xED ;                                
  if(Shut_All_MOS & 0x40) GPIO0->DOUT |= 0x02 ;                  // P0.1 ض MOS                                 
  GPIO0->PMD  = Px7_QB | Px6_QB | Px5_QB | Px4_OUT | Px1_OUT | Px0_OUT ;  // P0.014567,        
  GCR->P0_MFP = 0xF010 ;                                         // P0.4_PWM5,P0.567_SPI
                           
  GPIO1->DOUT = 0xFE ;                                           // P3.012456  
  GPIO1->PMD  = 0 ;                                              // P1.02345,
  GPIO1->OFFD = 0x00FF0000 ;  
  GPIO1->DMASK= 0xDF ;                                           // P1.5ҪADC
  GCR->P1_MFP = 0x113D ;                                         // P1.04_ACMP0, P1.235_ADC
                             
  GPIO2->DOUT = Shut_All_MOS << 2 ;                    
  GPIO2->PMD  = Px6_OUT | Px5_OUT | Px4_OUT | Px3_OUT | Px2_OUT ;    
  GCR->P2_MFP = 0x7C00 ;                                         // P2.23456 ,PWM01234

  GPIO3->DOUT = 0xFF ;                                           // P3.012456 
  GPIO3->PMD  = Px6_OUT  ;                                   
  GPIO3->OFFD = 0x00FF0000 ;  
  GPIO3->DMASK= 0x3F ;
  GCR->P3_MFP = 0x01003332 ;                                     // P3.0245_ACMP1, P3.1_AIN7

  GPIO4->DOUT = 0xFF ;
  GPIO4->PMD  = Px7_QB | Px6_QB ;                                // P4.67,ICEӿ
//  GCR->P4_MFP = 0 ;                              // ΪGPIO  NuLink         

  GPIO5->DOUT = 0xFF ;                                           // P5.012345 ,(QFN33ûP5.5)
  GPIO5->PMD  = Px5_OUT | Px4_QB | Px2_QB | Px1_QB | Px0_QB ;   
  GCR->P5_MFP = 0x0008 ;                                         // P5.3_ADC0,P5.2_INT1
   
  GPIO5->IMD  = 0x00 ;                                           // Edge interrupt mode
//  GPIO5->ISR  = ~0 ;                                           // ־ʹж֮ǰ
  GPIO5->IER  = 0 ;                                              // λ0~7жʹ,16~23ʹ
  GPIO5->DBEN = 0x04 ;                                           // P5.2 Enable De-bounce
  GPIODBNCE   = 0x2B ;					                         // De-bounce time = 2048HCLK

  NVIC_SetPriority(EINT1_IRQn, 2) ;                              //Interrupt priority = 2 
  NVIC->ISER[0] = 1<<EINT1_IRQn ;	 	 				           
}
//=======================================================================================
// MAIN function                                                               
//---------------------------------------------------------------------------------------
int main(void) 
{  
  uint32_t  temp32 = 0 ;  
  uint32_t  TickStop ;  
  
  Timer_ACMP_PWM_Init() ;                                  // Timer1,Delayus()
  PWM->CNR0 = 100*PWM_ONE_PERCENT - 1 ;                    //  PWM                             
  PWM->CNR1 = 100*PWM_ONE_PERCENT - 1 ;                    // ģʽ, ֻдPWM01  
  Current_Cofficient = 65536ul/(100*PWM_ONE_PERCENT);      // Уϵ

  ADC->CR     = ADCR_EN ;                                  // 輸ʮ΢ȶ
  ADC->ADSAMP = 4 ;                                        // ʱ 1+8 = 9CLK
  ADC->ADTDCR = 0 ;               
	
  //  BOD ѹǷΪ 3.7V ±ָλ //////////////////////////////////////////
#if 0
  CLK->AHBCLK |= CLK_ISP_EN ;
  FMC->ISPCON |= FMC_CFGUEN | FMC_EN_ ; 
  FMC->ISPADR  = 0x00300000 ;                              // Config0
  FMC->ISPCMD  = FMC_READ_0 ;                              // Read config0 
  FMC->ISPTRG  = 1 ;
  while(FMC->ISPTRG & 1) ; 
  temp32 = FMC->ISPDAT ;
  if((temp32 & (0x08000000 |                               // bit27=12*22.1184M
                0x00F80000 |                               // bit19~23=0100_0 BODλѹ 
                0x00000400 |                               // bit10=1ϵPINȫ 
                0x00008000 |                               // Bit15=1 HIRC  Ƶ                                   
 //               0x00000002 |                             // bit1=0, ڷ             
                0x000000C0))  != 0x08408480){              // bit7~6 =10, APROM with IAP                                   
    FMC->ISPCMD = FMC_ERASE ;   
    FMC->ISPTRG = 1 ;
    while(FMC->ISPTRG & 1) ;
    FMC->ISPDAT = 0xFF47FFBD ;                             // FF47FFBD, bit1=0 
    FMC->ISPCMD = FMC_WRITE ;                              //  BOD ѹд 3.7V ¸λ
    FMC->ISPTRG = 1 ;
    while(FMC->ISPTRG & 1) ;
    GCR->IPRST_CTL1 = 1 ;                                  // Chip Reset 
  }
  FMC->ISPCON &= ~(FMC_CFGUEN | FMC_EN_) ; 
  CLK->AHBCLK &= ~CLK_ISP_EN ; 
#endif  
  LOCKREG();   
  
  GPIO_Init() ;           // PWM,GPIO,GPIO״̬,Ϊȷֵ
//  UART0_Init(115200) ; 
  Set_BLDC_Free() ;  
  
  ///////////////////////////////////////////////////////////////////////////////////////
  Tick_Voltage = TIMER1->DR ;
  PWM->PHCHG = Shut_All_MOS ^ 0x42 ;  Delayus( 5*1000);    // PWM1 A- 
  PWM->PHCHG = Shut_All_MOS ^ 0x4A ;  Delayus( 5*1000);    // PWM13ͨ, B-
  PWM->PHCHG = Shut_All_MOS ^ 0x6A ;  Delayus(20*1000);    // ·MOS ȫͨ, Ծٵݳ        
  PWM->PHCHG = Shut_All_MOS ;         Delayus(10) ;        // ԾٵݳʱӰ0ֵĲ
  
  ADC->CHER    = ADC7_CURRENT ;                          
  Current_Zero = 0 ;  
  for(temp32=0; temp32<8; ++temp32){                       // 0 ADC ֵ, 8ƽ
    ADC->CR |= ADCR_START_BUSY ;  
    Delayus(50);
    Current_Zero += (uint16_t)ADC->DR ; 
  }
  Current_Zero >>= 3 ;                                          

  NVIC_SetPriority(ADC_IRQn, 0) ;                        
  NVIC->ISER[0] = 1 << ADC_IRQn ;    	  
  ADC->CR = ADCR_EN | ADCR_IE | ADCR_PWM_TRG | ADCR_TRG_EN;      // ʹPWMADC,ʹж 
  LED_DARK() ;
  
//  gFlag        = Flag_VOLTAGE_LOW;                       //ϵѹ־1
  while(1){      
    if(Adc_Vin < Vin_Min){                                 // ѹ                                         
      Vin_Min =  VIN_MIN_H ;
      gFlag  |=  Flag_VOLTAGE_LOW ;                        // ѹ־1 
      Tick_Voltage = TIMER1->DR ;
    }
    else if((TIMER1->DR - Tick_Voltage) >= 10*1000){       // ѹһʱ  
      Vin_Min =  VIN_MIN_L ;
      gFlag  &= ~Flag_VOLTAGE_LOW ;                        // ѹ־
    }        
    	  
    temp32 = Duty_Command ;                                // ռձָ,תָ 
    if(gFlag & 0x0FFF) temp32 = 0 ;                                   // 
    else if((Adc_Vin > VIN_HIGH)||(temp32 < Duty_Min))temp32 =0;      // ѹ̫߻С,ת
    else if(temp32 > 110*PWM_ONE_PERCENT) temp32 = 110*PWM_ONE_PERCENT ;    
	  
    BLDC_Control(temp32) ;                                       // Ƶ   

    if((gFlag & Flag_VOLTAGE_LOW) == 0){ GPIO3->DOUT |= 0x40;    // ѹ,ͨܵԴͨ· 
      TickStop = SysTick_Relay ;              
    }      
    else{                                                        // ԴضϿ,ѹ̫
      if(TIMER1->CSR & T_IE) TickStop = SysTick_Relay ;  
      else{          
        if((TickStop - SysTick_Relay) > 5) GPIO3->DOUT &= ~0x40; // ͣתʱ,ϿܵԴͨ·  
      }        
    }    
    ////===== Ŵ ==============================================================
  } 
}
const uint32_t AdcCh[8] = { ADC7_CURRENT, ADC5_VIN, 
                            ADC7_CURRENT, ADC2_TEMPERATURE, 
                            ADC7_CURRENT, ADC5_VIN,
                            ADC7_CURRENT, ADC0_SPEED };
void  ADC_IRQHandler(void)                                   // תٺܸ,ADC жϲܺʱ̫,
{                                                            // ADCжȼ,ʱ̫Ӱ0
   int32_t        temp32 ;  
  uint32_t static Turn_ADC = 0 ;   
	 int32_t static LastCurrent=0, CurrentNow=0 ;  
  
  temp32 = ADC->DR & 0xFFFF ;
  switch(ADC->CHER & 0xFF){  
  case ADC7_CURRENT : 
    temp32 -= Current_Zero ;	                                   // ʹܵͨʱĵֵ
    Adc_Current = temp32 ;
    if(temp32 > CURRENT_PEAK){            Duty_Limit -=  1;      
      if(temp32 > (CURRENT_PEAK*39>>5))    Duty_Limit -= 40;     // һμ5%, 2msɼ80%
      else if(temp32 >(CURRENT_PEAK*35>>5)) Duty_Limit -= 4;     // μԼ0.5% 
      TickChangDuty = TIMER1->DR ;                    // ֹͣӵѹ,תȥ         
    }
  
    if(temp32 < 0) temp32 = 0 ;                             // ,ƹʾͲزƽ
    else if(PWM->CMR0 <PWM->CNR0)temp32 =(temp32*PWM->CMR0*Current_Cofficient)>>16; // ھֵ                        
    temp32 = temp32 +((CurrentNow*55 -LastCurrent*24)>>5) ;   // ׵ͨ,תƵ13.8K/2/30= 230Hz 
    LastCurrent = CurrentNow;    CurrentNow = temp32 ;
    CurrentAvg = temp32 >> 5 ;

    break ;     
      
  case ADC5_VIN :                                       //330K 20K ѹ, õ0.1Vֵ  
    temp32  = (temp32*35*50 +1024) >>11 ;               // V =ADC*50/1024*(350K/20K)= ADC*35*50/2048 
//    Adc_Vin = (Adc_Vin + temp32) >>1  ;                       
    if(Adc_Vin < VIN_MIN_L) gFlag |= Flag_VOLTAGE_LOW ;    
    break ;
      
  case ADC0_SPEED : 	
 //   Duty_Command = (Duty_Command*15 + temp32+8) >> 4 ;         // ťֵ 13.8K/6/94= 24Hz                   
    break ;
            
  case ADC2_TEMPERATURE :                                        // ¶
    if(CurrentAvg > CURRENT_LIMIT){ TickChangDuty = TIMER1->DR ;   
      --Duty_Limit ; 
    }
    break ;
  }                       

  if(++Turn_ADC >= 8) Turn_ADC = 0 ;
  ADC->CHER = AdcCh[Turn_ADC] ;  
  ADC->SR  |= ADSR_ADF ;                                         // жϱ־
  
  if(gFlag & Flag_VOLTAGE_LOW) Duty_Limit = 0;                   // ѹ,ռձ=0
  else if(Duty_Limit < 29 ) Duty_Limit = 29 ;
  
  PWM->CMR0 = Duty_Limit; 
}

void SysTick_Handler(void)                                       // 100ms жһ
{	
  uint32_t static LED_Data = 0 ;
	
  --SysTick_Relay ; 

  if(gFlag & (Flag_SHORT | Flag_OPEN | Flag_TEMPERATURE_OVER | Flag_VOLTAGE_LOW)){	
    if(gFlag & Flag_SHORT)                 LED_Data = 0x0AA0;    // ·,Ĵ	
    else if(gFlag & Flag_TEMPERATURE_OVER) LED_Data = 0x00A0;    // ,	
    else  LED_Data = 0xFFC;                                      // ѹ,һ
    
  }
  else LED_Data = 0x007;                                         // 
  
  if(LED_Flash & 1) LED_LIGHT() ;
  else LED_DARK() ;
  LED_Flash >>= 1 ;    
  if(LED_Flash == 0){LED_Flash = LED_Data;   LED_Data = 0; }     
  
#if 0	                                                           // ӡٶ
  {
    uint32_t static Cnt = 0, flag = 0 ;
    uint8_t  str[] = "Duty=   %         rpm\n\r" ; 
      
    if(++Cnt >= 25){  Cnt = 0 ; flag ^= 1 ;                      // 20ms X 25 =0.5S
      if(flag == 0){  
        HexToStr(10000000/PeriodNow, &str[16]) ;                 // תתַ
        Tx0FillFiFo(&str[10],13) ;                               // д Tx0
      }
      else{  
        HexToStr(PWM->CMR0/PWM_ONE_PERCENT, &str[7]) ;           // ռձתַ
        Tx0FillFiFo(str,10) ;                                    // д Tx0
      }
    }      
  }
#endif	
}
